
#ifndef __INC_NORMAL__
#define __INC_NORMAL__

#include <cmath>

int ipmpar(int *i);

double devlpl(double a[],int *n,double *x);
double spmpar(int *i);
double stvaln(double *p);
double fifdint(double a);
double dexpm1(double *x);

void cumnor(double *arg,double *result,double *ccum);

double dinvnr(double *p,double *q);
void cdfnor(int which, double* p, double* q, double* x, double* mean,
	    double* sd, int* status, double* bound);

double black_scholes_log( const double x, const double strike, 
						  const double t, const double sigma, 
						  const double r_d, const double r_f );
/*
 *	return Black-Scholes call option price for parameters
 *		x = log(Spot/Strike)
 *		strike = K = strike level
 *	 	t = time to maturity
 *		sigma = (implied) volatility
 *		r_d = domestic interest rate
 *		r_f = foreign interest rate
 *		
 *	price = K * exp( x - r_f t) Phi(d+) - K * exp(- r_d t) Phi(d-)
 *	d(+/-) = x / (sigma*sqrt(t)) + (r_d-r_f (+/-) sigma^2/2)*sqrt(t)/sigma
 *	
 *	Phi(x) = cdf(x) = value of cumulated normal denstity fct. 
 */

double black_scholes_downout( const double x, const double strike, 
							  const double t, const double sigma, 
							  const double r_d, const double r_f,
							  const double barrier);
/* return Black-Scholes option price of Down-Out Call w/o rebate */

#endif
